﻿定型文機能設定:
	Gui,2: New
	;=========================================== 機能設定画面を操作不可にする
	Gui,1:Hide
	;-------------------------------------- 既に設定画面を開いているときは何もしない
	IfWinExist 定型文機能設定
	{
		Return
	}
	;=========================================== 定型文を編集できるかどうか判定する変数を初期化
	EnablePhraseEdit := 1
	;=========================================== フォントの設定
	Gui,2: Font, s11, 
	;=========================================== 定型文グループ
	Gui,2: Add, GroupBox, x22 y9 w420 h360 , 定型文グループ
	Gui,2: Add, ListView, x42 y39 w380 h230 NoSortHdr Grid -Multi AltSubmit vPhraseGroupLV gOnActionPhraseGroup, 定型文グループ
	Gui,2: Add, Button, x52 y279 w40 h30 disabled1 vPhraseGroupUpBtn gPhraseGroupUp, ↑
	Gui,2: Add, Button, x102 y279 w40 h30 disabled1 vPhraseGroupDownBtn gPhraseGroupDown, ↓
	Gui,2: Add, Button, x182 y279 w70 h30 gPhraseGroupAdd, 追加
	Gui,2: Add, Button, x262 y279 w70 h30 disabled1 vPhraseGroupModifyBtn gPhraseGroupModify, 変更
	Gui,2: Add, Button, x342 y279 w70 h30 disabled1 vPhraseGroupDeleteBtn gPhraseGroupDelete, 削除
	Gui,2: Add, Button, x182 y319 w230 h30 disabled1 vPhraseGroupSaveBtn gPhraseGroupSave, 保存
	;--------------- 削除した定型文グループ番号を保管する配列を定義する
	FP_DeleteGroup := Object()
	FP_DeleteGroupCount := 0
	;--------------- 定型文・グループメニューを読み込んでリストビューに追加する
	Global FP_OrderMem := Object()
	Global FP_GroupNameMem := Object()
	Global FP_GroupCountMem := 0
	Loop {
		;--------------- 定型文・表示順情報を読み込む
		Key = FIXED_PHRASE_ORDER%A_Index%
		IniRead, Order, %IniFileName%, FIXED_PHRASE_ORDER, %Key%, -1
		If (Order == -1) {
			Break
		}
		;--------------- 定型文・グループメニューを読み込む
		Section = FIXED_PHRASE%Order%
		IniRead, FP_MenuGroup, %IniFileName%, %Section%, MenuGroup, -1
		;--------------- 定型文・グループ情報を配列に保存する
		FP_OrderMem[A_Index] := Order
		FP_GroupNameMem[Order] := FP_MenuGroup
		;--------------- 定型文・グループ数をカウントする
		If (Order > FP_GroupCountMem) {
			FP_GroupCountMem := Order
		}
	}
	;--------------- 定型文・グループリストビューを構築する
	Gosub BuildPhraseGroupLV
	;=========================================== 定型文
	Gui,2: Add, GroupBox, x462 y9 w420 h360 , 定型文
	Gui,2: Add, ListView, x482 y39 w380 h230 NoSortHdr Grid -Multi AltSubmit vPhraseLV gOnActionPhrase, メニュー表示|定型文
	Gui,2: Add, Button, x492 y279 w40 h30 disabled1 vPhraseUpBtn gPhraseUp, ↑
	Gui,2: Add, Button, x542 y279 w40 h30 disabled1 vPhraseDownBtn gPhraseDown, ↓
	Gui,2: Add, Button, x782 y279 w70 h30 disabled1 vPhraseDeleteBtn gPhraseDelete, 削除
	Gui,2: Add, Button, x622 y319 w230 h30 disabled1 vPhraseSaveBtn gPhraseSave, 保存
	;=========================================== 定型文の内容
	Gui,2: Add, GroupBox, x22 y379 w860 h310 , 定型文の編集
	Gui,2: Add, Text, x42 y409 w90 h20 , 定型文
	Gui,2: Add, Edit, x42 y439 w380 h190 disabled1 vPhraseContents gOnChangePhraseContents, 
	Gui,2: Add, Button, x182 y639 w230 h30 disabled1 vCopyPhraseToMenuBtn gCopyPhraseToMenu, メニュー表示にコピー
	Gui,2: Add, Text, x472 y409 w90 h20 , メニュー表示
	Gui,2: Add, Edit, x482 y439 w380 h20 disabled1 vPhraseMenuText gOnChangePhraseMenuText, 
	Gui,2: Add, Button, x502 y639 w90 h30 disabled1 vPhraseClearBtn gPhraseClear, クリア
	Gui,2: Add, Button, x622 y599 w230 h30 disabled1 vPhraseAddBtn gPhraseAdd, 追加
	Gui,2: Add, Button, x622 y639 w230 h30 Disabled1 vPhraseModifyBtn gPhraseModify, 変更
	;=========================================== 前回終了時に設定画面が表示されていた場合はリストビューの選択状態を復元する
	IniRead,strWrk,%IniFileName%,AUTOEXEC,StartUp,0
	If (strWrk == 1) {
		;--------------- 再表示指定をクリアする
		IniWrite,0,%IniFileName%,AUTOEXEC,StartUp
		;--------------- 定型文グループリストビューの選択状態を復元する
		IniRead,strWrk,%IniFileName%,AUTOEXEC,FP_GrSelectedRow
		If (strWrk > 0) {
			Gui,2:ListView,PhraseGroupLV
			LV_Modify(strWrk, "Select")
			SelectedRow := strWrk
			Gosub ExpandGroupPhrase
		}
		;--------------- 定型文リストビューの選択状態を復元する
		IniRead,strWrk,%IniFileName%,AUTOEXEC,FP_PhSelectedRow
		If (strWrk > 0) {
			Gui,2:ListView,PhraseLV
			LV_Modify(strWrk, "Select")
			SelectedRow := strWrk
			Gosub ExpandPhrase
		}
	}
	Gui,2: Add, Button, x782 y698 w100 h30 g2ConfigClose, 閉じる
	;=========================================== 画面表示
	Gui,2: Show, h741 w907, 定型文機能設定
Return
;=========================================== 定型文グループの項目が選択されたときの処理
OnActionPhraseGroup:
	;-------------------------------------- リストビューがフォーカスを受け取ったときは、処理対象のリストビューを変更する
	If (A_GuiEvent == "F" || A_GuiEvent == "Normal") {
		Gui, 2:ListView, PhraseGroupLV
	}
	;-------------------------------------- リストビューの選択状態が変化したときは、リストビューにフォーカスをあわせる（ここでフォーカスをあててないと次にリストビューの項目をクリックしたときに正しくイベントが受け取れないため）
	If (A_GuiEvent == "I") {		
		GuiControl, Focus, PhraseGroupLV
		Return
	}
	;------------------------------ 選択されている行の行番号を取得する
	SelectedRow := LV_GetNext(0)
	;------------------------------ 項目が埋まっている行がクリックされたときだけ処理する
	If (A_GuiEvent == "Normal" || (A_GuiEvent == "K" && (A_EventInfo == "38" || A_EventInfo == "40"))) {
		If (SelectedRow > 0) {
			;-------------------------------------- 選択された定型文グループの登録内容を展開する
			Gosub ExpandGroupPhrase
		}Else{
			;-------------------------------------- ボタンを押せないようにする
			GuiControl, Enable0, PhraseGroupUpBtn
			GuiControl, Enable0, PhraseGroupDownBtn
			GuiControl, Enable0, PhraseGroupModifyBtn
			GuiControl, Enable0, PhraseGroupDeleteBtn
			GuiControl, Enable0, PhraseGroupSaveBtn
			GuiControl, Enable0, PhraseUpBtn
			GuiControl, Enable0, PhraseDownBtn
			GuiControl, Enable0, PhraseDeleteBtn
			GuiControl, Enable0, PhraseSaveBtn
			GuiControl, Enable0, CopyPhraseToMenuBtn
			GuiControl, Enable0, PhraseClearBtn
			GuiControl, Enable0, PhraseAddBtn
			GuiControl, Enable0, PhraseModifyBtn
		}	
	}
Return
;=========================================== 定型文グループの登録内容を展開する
ExpandGroupPhrase:
	;-------------------------------------- 選択された定型文グループのアイテムをリストビューに追加する
	;-------------------------------------- 定型文リストビューを処理対象に変更する
	Gui,2:ListView,PhraseLV
	;-------------------------------------- リストビューをいったん削除する
	LV_Delete()
	;-------------------------------------- 定型文のコンテンツとメニューを読み込んで定型文リストビューに追加する
	FP_No := FP_OrderMem[SelectedRow]
	Section = FIXED_PHRASE%FP_No%
	loop {
		Key = MenuText%A_Index%
		IniRead, FP_PhraseMenuText, %IniFileName%, %Section%, %Key%, -1
		If (FP_PhraseMenuText == -1) {
			Break
		}
		Key = Contents%A_Index%
		IniRead, FP_PhraseContents, %IniFileName%, %Section%, %Key%, -1
		LV_Add("", FP_PhraseMenuText, FP_PhraseContents)
	}
	;-------------------------------------- リストビューの列幅を調整する
	LV_ModifyCol(1,"AutoHdr")
	;-------------------------------------- 定型文グループリストビューを処理対象に変更する
	Gui,2:ListView,PhraseGroupLV
	;-------------------------------------- 定型文グループと定型文のボタンを制御する
	Gui,2: Submit ,NoHide
	GuiControl, Enable0, PhraseSaveBtn
	;-------------------------------------- ボタン等を制御する
	SelectedRow := LV_GetNext(0)
	If (SelectedRow > 0) {
		GuiControl, Enable1, PhraseGroupUpBtn
		GuiControl, Enable1, PhraseGroupDownBtn
		GuiControl, Enable1, PhraseGroupModifyBtn
		GuiControl, Enable1, PhraseGroupDeleteBtn
		;-------------------------------------- 定型文が編集できるときはボタン等を有効にする
		If (EnablePhraseEdit == 1) {
			GuiControl, Enable1, PhraseContents
			GuiControl, Enable1, PhraseMenuText
			If (StrLen(PhraseContents) > 0 && StrLen(PhraseMenuText) > 0) {
				GuiControl, Enable1, PhraseAddBtn
				GuiControl, Enable1, PhraseClearBtn
			}
		}
	}Else{
		GuiControl, Enable0, PhraseGroupUpBtn
		GuiControl, Enable0, PhraseGroupDownBtn
		GuiControl, Enable0, PhraseGroupModifyBtn
		GuiControl, Enable0, PhraseGroupDeleteBtn
		GuiControl, Enable0, PhraseGroupSaveBtn
	}
	;--------------- 定型文の変更ボタンを押せないようにする
	GuiControl, Enable0, PhraseModifyBtn
Return
;=========================================== 定型文グループの↑ボタンを押したときの処理
PhraseGroupUp:
	;-------------------------------------- 選択されている行を上げる
	PhraseGroupUpDown("Up")
Return
;=========================================== 定型文グループの↓ボタンを押したときの処理
PhraseGroupDown:
	;-------------------------------------- 選択されている行を下げる
	PhraseGroupUpDown("Down")
Return
;=========================================== 定型文グループのリストビューを上下する
PhraseGroupUpDown(UpDown) {
	;-------------------------------------- 定型文グループリビューを処理対象に変更する
	Gui,2:ListView,PhraseGroupLV
	;-------------------------------------- 選択されている行の番号を取得する
	SelectedRow := LV_GetNext(0)
	If (UpDown == "Up") {
		If (SelectedRow > 1) {
			AltRow := SelectedRow - 1
		}Else{
			AltRow := 0
		}
	}Else{
		If (SelectedRow < LV_GetCount()) {
			AltRow := SelectedRow + 1
		}Else{
			AltRow := 0
		}
	}
	If (AltRow > 0) {
		;-------------------------------------- 順番を変更する
		Wrk := FP_OrderMem[AltRow]
		FP_OrderMem[AltRow] := FP_OrderMem[SelectedRow]
		FP_OrderMem[SelectedRow] := Wrk
		;-------------------------------------- リストビューをいったん削除する
		LV_Delete()
		;-------------------------------------- リストビューを再構築する
		Gosub BuildPhraseGroupLV
		;-------------------------------------- 移動したグループを選択する
		LV_Modify(AltRow,"Select Vis")
		;-------------------------------------- 定型文グループを変更した時は保存するまで定型文のボタンを押せないようにする
		Gosub PhraseDisableButton
		;-------------------------------------- 定型文グループの保存ボタンを押せるようにする
		GuiControl, Enable1, PhraseGroupSaveBtn
	}
}
;=========================================== 定型文グループの追加ボタンを押したときの処理
PhraseGroupAdd:
	InputBox, NewGroup, 定型文グループの追加, 定型文グループ名を入力してください
	If (StrLen(NewGroup) > 0) {
		;-------------------------------------- 定型文グループリストビューを処理対象に変更する
		Gui,2:ListView,PhraseGroupLV
		LV_Add("", NewGroup)
		;--------------- リストビューの列幅を調整する
		LV_ModifyCol(1,"AutoHdr")
		;-------------------------------------- 表示順を保存する
		LV_Count := LV_GetCount()
		FP_GroupCountMem += 1
		FP_OrderMem[LV_Count] := FP_GroupCountMem
		FP_GroupNameMem[FP_GroupCountMem] := NewGroup
		;-------------------------------------- 定型文グループを変更した時は保存するまで定型文のボタンを押せないようにする
		Gosub PhraseDisableButton
		;-------------------------------------- 定型文グループの保存ボタンを押せるようにする
		GuiControl, Enable1, PhraseGroupSaveBtn
	}
Return
;=========================================== 定型文グループの変更ボタンを押したときの処理
PhraseGroupModify:
	;-------------------------------------- 定型文グループリストビューを処理対象に変更する
	Gui,2:ListView,PhraseGroupLV
	SelectedRow := LV_GetNext(0)
	LV_GetText(strWrk, SelectedRow, 1)
	InputBox, AltGroup , 定型文グループの変更, 定型文グループ名を入力してください, , , , , , , , %strWrk%
	If (ErrorLevel == 0 && StrLen(AltGroup) > 0) {
		LV_Modify(SelectedRow,,AltGroup)
		;-------------------------------------- 表示順を保存する
		strWrk := FP_OrderMem[SelectedRow]
		FP_GroupNameMem[strWrk] := AltGroup
		;-------------------------------------- 定型文グループを変更した時は保存するまで定型文のボタンを押せないようにする
		Gosub PhraseDisableButton
		;-------------------------------------- 定型文グループの保存ボタンを押せるようにする
		GuiControl, Enable1, PhraseGroupSaveBtn
	}
Return
;=========================================== 定型文グループの削除ボタンを押したときの処理
PhraseGroupDelete:
	;-------------------------------------- 定型文グループリストビューを処理対象に変更する
	Gui,2:ListView,PhraseGroupLV
	;-------------------------------------- 削除対象業を保管する
	SelectedRow := LV_GetNext(0)
	LV_LastCount := LV_GetCount()
	;-------------------------------------- 選択されている定型文を削除する
	Rs := DeleteSelectedRow()
	If (Rs == 0) {
		;-------------------------------------- 定型文リストビューを処理対象に変更する
		Gui,2:ListView,PhraseLV
		;-------------------------------------- 定型文リストビューをクリアする
		LV_Delete()
		;-------------------------------------- 削除した定型文グループ番号を保存する
		FP_DeleteGroupConut += 1
		FP_DeleteGroup[FP_DeleteGroupConut] := FP_OrderMem[SelectedRow]
		;-------------------------------------- 定型文グループ表示順を保管した配列をコピーする
		FP_OrderMem_Cpy := Object()
		For index, OptOdr in FP_OrderMem {
			FP_OrderMem_Cpy[index] := FP_OrderMem[index]
		}
		;-------------------------------------- 削除した定型文グループを0クリアする
		FP_OrderMem_Cpy[SelectedRow] := 0
		;-------------------------------------- 定型文グループ表示順を保管した配列を再構築する
		FP_OrderMem := Object()
		ix := 0
		For index, OptOdr in FP_OrderMem_Cpy {
			If (FP_OrderMem_Cpy[index] > 0) {
				ix += 1
				FP_OrderMem[ix] := FP_OrderMem_Cpy[index]
			}
		}
		;-------------------------------------- 定型文グループを変更した時は保存するまで定型文のボタンを押せないようにする
		Gosub PhraseDisableButton
		;-------------------------------------- 定型文グループのボタンを制御する
		GuiControl, Enable1, PhraseGroupSaveBtn
		GuiControl, Enable0, PhraseGroupUpBtn
		GuiControl, Enable0, PhraseGroupDownBtn
		GuiControl, Enable0, PhraseGroupModifyBtn
		GuiControl, Enable0, PhraseGroupDeleteBtn
	}
Return
;=========================================== 定型文グループの保存ボタンを押したときの処理
PhraseGroupSave:
	;SplashImage,,B1 FM12 CWFFFFA2,,定型文グループを保存しています
	;-------------------------------------- 表示順をいったん削除する
	IniDelete,%IniFileName%,FIXED_PHRASE_ORDER
	;-------------------------------------- 表示順を再構築する
	For index, Order in FP_OrderMem {
		Key = FIXED_PHRASE_ORDER%index%
		IniWrite,%Order%,%IniFileName%,FIXED_PHRASE_ORDER,%key%
	}
	;-------------------------------------- メニューグループを保存する
	For index, Order in FP_OrderMem {
		;-------------------------------------- メニューグループを保存する
		Section = FIXED_PHRASE%Order%
		FP_MenuGroup := FP_GroupNameMem[Order]
		IniWrite,%FP_MenuGroup%,%IniFileName%,%Section%,MenuGroup
	}
	;-------------------------------------- 削除グループを削除する
	For index, Delete in FP_DeleteGroup {
		Section = FIXED_PHRASE%Delete%
		IniDelete,%IniFileName%,%Section%
	}
	;SplashImage,off
	;-------------------------------------- 定型文をiniファイルから読み込んでメニューを構築
	Gosub BuildOptionMenu1
	;-------------------------------------- 再表示時に復元できるようにリストビューの選択状態を保存してリロードする
	Gosub SaveLastSessionAndReloadFP
	;MsgBox 定型文グループを保存しました
	;-------------------------------------- 保存時に定型文グループの項目が選択されていた時は定型文を入力できるようにする
	;Gui,2: Submit ,NoHide
	;SelectedRow := LV_GetNext(0)
	;If (SelectedRow > 0) {
	;	GuiControl, Enable1, PhraseContents
	;	GuiControl, Enable1, PhraseMenuText
	;	If (StrLen(PhraseContents) > 0 && StrLen(PhraseMenuText) > 0) {
	;		GuiControl, Enable1, PhraseAddBtn
	;	}
	;}
	;-------------------------------------- 定型文を編集できるようにする
	;EnablePhraseEdit := 1
Return
;=========================================== 定型文リストビューの項目が選択されたときの処理
OnActionPhrase:
 	;-------------------------------------- リストビューがフォーカスを受け取ったときは、処理対象のリストビューを変更する
	If (A_GuiEvent == "F" || A_GuiEvent == "Normal") {
		Gui, 2:ListView, PhraseLV
	}
	;-------------------------------------- リストビューの選択状態が変化したときは、リストビューにフォーカスをあわせる（ここでフォーカスをあててないと次にリストビューの項目をクリックしたときに正しくイベントが受け取れないため）
	If (A_GuiEvent == "I") {		
		GuiControl, Focus, PhraseLV
		Return
	}
	;------------------------------ 項目が埋まっている行がクリックされたときだけ処理する
	If (A_GuiEvent == "Normal" || (A_GuiEvent == "K" && (A_EventInfo == "38" || A_EventInfo == "40"))) {
		;------------------------------ 選択されている行の行番号を取得する
		SelectedRow := LV_GetNext(0)
		If (SelectedRow > 0) {
			;-------------------------------------- 定型文の登録内容を展開する
			Gosub ExpandPhrase
		}Else{
			;-------------------------------------- ボタンを押せないようにする
			GuiControl, Enable0, PhraseGroupUpBtn
			GuiControl, Enable0, PhraseGroupDownBtn
			GuiControl, Enable0, PhraseGroupModifyBtn
			GuiControl, Enable0, PhraseGroupDeleteBtn
			GuiControl, Enable0, PhraseGroupSaveBtn
			GuiControl, Enable0, PhraseUpBtn
			GuiControl, Enable0, PhraseDownBtn
			GuiControl, Enable0, PhraseDeleteBtn
			GuiControl, Enable0, PhraseSaveBtn
			GuiControl, Enable0, CopyPhraseToMenuBtn
			GuiControl, Enable0, PhraseClearBtn
			GuiControl, Enable0, PhraseAddBtn
			GuiControl, Enable0, PhraseModifyBtn
		}	
	}
Return
;=========================================== 定型文の登録内容を展開する
ExpandPhrase:
	IF (SelectedRow > 0) {
		;-------------------------------------- 選択された定型文をエディットボックスに追加する
		;-------------------------------------- 定型文リストビューを処理対象に変更する
		Gui,2:ListView,PhraseLV
		;-------------------------------------- メニュー表示をリストビューから取得しエディットボックスに表示する
		LV_GetText(strWrk, SelectedRow, 1)
		GuiControl, Text, PhraseMenuText, %strWrk%
		SelectedPhraseMenuText := strWrk
		;-------------------------------------- 定型文を取得しリストビューからエディットボックスに表示する
		LV_GetText(strWrk, SelectedRow, 2)
		;-------------------------------------- 改行を復元
		Gosub DecodeLFCR_TAB
		GuiControl, Text, PhraseContents, %strWrk%
		;-------------------------------------- ボタンを制御する
		GuiControl, Enable1, PhraseUpBtn
		GuiControl, Enable1, PhraseDownBtn
		GuiControl, Enable1, PhraseDeleteBtn
		GuiControl, Enable1, CopyPhraseToMenuBtn
		;-------------------------------------- 定型文の登録内容展開フラグを立てる
		IsExpandPhrase := 1
		;-------------------------------------- 定型文の追加・変更ボタンを押せないようにする
		GuiControl, Enable0, PhraseAddBtn
		GuiControl, Enable0, PhraseModifyBtn
	}
Return
;=========================================== 定型文メニューの↑ボタンを押したときの処理
PhraseUp:
	;-------------------------------------- 選択されている行を上げる
	PhraseUpDown("Up")
Return
;=========================================== 定型文メニューの↓ボタンを押したときの処理
PhraseDown:
	;-------------------------------------- 選択されている行を下げる
	PhraseUpDown("Down")
Return
;=========================================== 定型文メニューのリストビューを上下する
PhraseUpDown(UpDown) {
	;-------------------------------------- 定型文リストビューを処理対象に変更する
	Gui,2:ListView,PhraseLV
	;-------------------------------------- 選択されている行の番号を取得する
	SelectedRow := LV_GetNext(0)
	If (UpDown == "Up") {
		If (SelectedRow > 1) {
			AltRow := SelectedRow - 1
		}Else{
			AltRow := 0
		}
	}Else{
		If (SelectedRow < LV_GetCount()) {
			AltRow := SelectedRow + 1
		}Else{
			AltRow := 0
		}
	}
	If (AltRow > 0) {
		;-------------------------------------- メニュー表示をリストビューから取得し配列に保存する
		PhraseMenuTextMem := Object()
		MenuPhraseContentsMem := Object()
		LV_Count := LV_GetCount()
		Loop %LV_Count% {
			LV_GetText(strWrk, A_Index, 1)
			PhraseMenuTextMem[A_Index] := strWrk
			LV_GetText(strWrk, A_Index, 2)
			MenuPhraseContentsMem[A_Index] := strWrk
		}
		;-------------------------------------- 順番を変更する
		Wrk := PhraseMenuTextMem[AltRow]
		PhraseMenuTextMem[AltRow] := PhraseMenuTextMem[SelectedRow]
		PhraseMenuTextMem[SelectedRow] := Wrk
		;-------------------------------------- 順番を変更する
		Wrk := MenuPhraseContentsMem[AltRow]
		MenuPhraseContentsMem[AltRow] := MenuPhraseContentsMem[SelectedRow]
		MenuPhraseContentsMem[SelectedRow] := Wrk
		;-------------------------------------- リストビューをいったん削除する
		LV_Delete()
		;-------------------------------------- リストビューを再構築する
		loop %LV_Count% {
			LV_Add("", PhraseMenuTextMem[A_Index], MenuPhraseContentsMem[A_Index])
		}
		;--------------- リストビューの列幅を調整する
		LV_ModifyCol(1,"AutoHdr")
		;-------------------------------------- 移動したグループを選択する
		LV_Modify(AltRow,"Select Vis")
		;-------------------------------------- ボタンを押せるようにする
		GuiControl, Enable1, PhraseSaveBtn
	}
}
;=========================================== 定型文の削除ボタンを押したときの処理
PhraseDelete:
	;-------------------------------------- 定型文リストビューを処理対象に変更する
	Gui,2:ListView,PhraseLV
	;-------------------------------------- 選択されている定型文を削除する
	Rs := DeleteSelectedRow()
	If (Rs == 0) {
		;-------------------------------------- ボタンを制御する
		GuiControl, Enable1, PhraseSaveBtn
		GuiControl, Enable0, PhraseUpBtn
		GuiControl, Enable0, PhraseDownBtn
		GuiControl, Enable0, PhraseModifyBtn
		GuiControl, Enable0, PhraseDeleteBtn
	}
Return
;=========================================== リストビューから選択されている行を削除
DeleteSelectedRow() {
	SelectedRow := LV_GetNext(0)
	LV_GetText(strWrk, SelectedRow, 1)
	MsgBox ,4,削除確認,「%strWrk%」を削除しますか？
	IfMsgBox YES
	{
		LV_Delete(SelectedRow)
		Return 0
	}Else{
		Return -1
	}
}
;=========================================== 定型文メニューの保存を押したときの処理
PhraseSave:
	;SplashImage,,B1 FM12 CWFFFFA2,,定型文を保存しています
	;-------------------------------------- 定型文グループリストビューを処理対象に変更する
	Gui,2:ListView,PhraseGroupLV
	;-------------------------------------- 選択されている行の番号を取得する
	SelectedRow := LV_GetNext(0)
	FP_No := FP_OrderMem[SelectedRow]
	Section = FIXED_PHRASE%FP_No%
	;-------------------------------------- 定型文グループをiniファイルから一旦削除する
	IniDelete,%IniFileName%,%Section%
	FP_GrName := FP_GroupNameMem[FP_No]
	;-------------------------------------- 定型文グループをiniファイルに保存する
	IniWrite,%FP_GrName%,%IniFileName%,%Section%,MenuGroup
	;-------------------------------------- 定型文リストビューを処理対象に変更する
	Gui,2:ListView,PhraseLV
	;-------------------------------------- リストビューに表示されている定型文をiniファイルに保存する
	LV_Count := LV_GetCount()
	Loop %LV_Count% {
		;-------------------------------------- メニューテキストをiniファイルに保存する
		LV_GetText(PhraseMenuTextLV, A_Index, 1)
		Key = MenuText%A_Index%
		IniWrite,%PhraseMenuTextLV%,%IniFileName%,%Section%,%Key%
		;-------------------------------------- コンテンツをiniファイルに保存する
		LV_GetText(PhraseContentsLV, A_Index, 2)
		Key = Contents%A_Index%
		IniWrite,%PhraseContentsLV%,%IniFileName%,%Section%,%Key%
	}
	;SplashImage,off
	;MsgBox 定型文を保存しました
	;-------------------------------------- 再表示時に復元できるようにリストビューの選択状態を保存してリロードする
	Gosub SaveLastSessionAndReloadFP
Return
;=========================================== 定型文を入力した時の処理
OnChangePhraseContents:
	Gosub OnChangePhrase
Return
;=========================================== 定型文メニューテキストを入力した時の処理
OnChangePhraseMenuText:
	Gosub OnChangePhrase
Return
;=========================================== 定型文とメニューテキストを入力した時の処理
OnChangePhrase:
	;-------------------------------------- リストビューの定型文を選択して定型文とメニューテキストが入力されたときは何もしない
	If (IsExpandPhrase == 1) {
		IsExpandPhrase := 0
		Return
	}
	Gui,2: Submit ,NoHide
	;-------------------------------------- 定型文リストビューを処理対象に変更する
	Gui,2:ListView,PhraseLV
	SelectedRow := LV_GetNext(0)
	If (SelectedRow > 0) {
		;--------------- 定型文リストビューの項目が選択されている時
		GuiControlGet, strWrk , FocusV
		If (strWrk == "PhraseLV") {
			;--------------- 定型文リストビューがアクティブになっているときは定型文の変更ボタンを押せないようにする
			GuiControl, Enable0, PhraseModifyBtn
		}Else{
			If (StrLen(PhraseContents) > 0 && StrLen(PhraseMenuText) > 0) {
				;--------------- 定型文の変更ボタンを押せるようにする
				GuiControl, Enable1, PhraseModifyBtn
				;--------------- 定型文のコピーボタンを押せるようよする
				GuiControl, Enable1, CopyPhraseToMenuBtn
			}Else{
				;--------------- 定型文の変更ボタンを押せないようにする
				GuiControl, Enable0, PhraseModifyBtn
				;--------------- 定型文のコピーボタンを制御する
				If (StrLen(PhraseContents) > 0) {
					GuiControl, Enable1, CopyPhraseToMenuBtn
				}Else{
					GuiControl, Enable0, CopyPhraseToMenuBtn
				}
			}
		}
	}Else{
		;--------------- 定型文リストビューの項目が選択されていない（新規追加の）時
		;--------------- 定型文の変更ボタンを押せないようにする
		GuiControl, Enable0, PhraseModifyBtn
		;--------------- 定型文のコピーボタンを制御する
		If (StrLen(PhraseContents) > 0) {
			GuiControl, Enable1, CopyPhraseToMenuBtn
		}Else{
			GuiControl, Enable0, CopyPhraseToMenuBtn
		}
	}
	;--------------- 定型文の追加ボタンを制御する
	If (StrLen(PhraseContents) > 0 && StrLen(PhraseMenuText) > 0 && SelectedPhraseMenuText <> PhraseMenuText) {
		;--------------- 定型文とメニュー表示が入力されていて、メニュー表示が定型文リストビューの選択されている内容と違う時だけ押せるようにする
		GuiControl, Enable1, PhraseAddBtn
	}Else{
		GuiControl, Enable0, PhraseAddBtn
	}
	;--------------- 定型文のクリアボタンを制御する
		If (StrLen(PhraseContents) > 0 || StrLen(PhraseMenuText) > 0) {
		GuiControl, Enable1, PhraseClearBtn
	}Else{
		GuiControl, Enable0, PhraseClearBtn
	}
Return
;=========================================== 定型文のメニュー表示にコピーを押したときの処理
CopyPhraseToMenu:
	GuiControl, Text, PhraseMenuText, %PhraseContents%
Return
;=========================================== 定型文のクリアボタンを押したときの処理
PhraseClear:
	GuiControl, Text, PhraseContents,
	GuiControl, Text, PhraseMenuText,
	GuiControl, Enable0, CopyPhraseToMenuBtn
	GuiControl, Enable0, PhraseAddBtn
	GuiControl, Enable0, PhraseModifyBtn
	;--------------- 定型文メニューテキストにフォーカスを移してクリアボタンを押せなくする（定型文にフォーカスを移動したのではうまくいかない）
	GuiControl, Focus , PhraseMenuText
	GuiControl, Focus , PhraseContents
Return
;=========================================== 定型文の追加ボタンを押したときの処理
PhraseAdd:
	;-------------------------------------- エディットボックスの内容を取得する
	Gui,2: Submit ,NoHide
	;-------------------------------------- 改行を置換
	strWrk := PhraseContents
	Gosub EncodeLFCR_TAB
	;-------------------------------------- 定型文リストビューを処理対象に変更する
	Gui,2:ListView,PhraseLV
	LV_Add("", PhraseMenuText, strWrk)
	;-------------------------------------- リストビューの列幅を調整する
	LV_ModifyCol(1,"AutoHdr")
	;-------------------------------------- 定型文の保存ボタンを押せるようにする
	GuiControl, Enable1, PhraseSaveBtn
Return
;=========================================== 定型文の変更ボタンを押したときの処理
PhraseModify:
	;-------------------------------------- エディットボックスの内容を取得する
	Gui,2: Submit ,NoHide
	;-------------------------------------- 改行を置換
	strWrk := PhraseContents
	Gosub EncodeLFCR_TAB
	;-------------------------------------- 定型文リストビューを処理対象に変更する
	Gui,2:ListView,PhraseLV
	;-------------------------------------- 選択されている行の番号を取得する
	SelectedRow := LV_GetNext(0)
	LV_Modify(SelectedRow, "Select", PhraseMenuText, strWrk)
	;--------------- リストビューの列幅を調整する
	LV_ModifyCol(1,"AutoHdr")
	;-------------------------------------- 定型文の保存ボタンを押せるようにする
	GuiControl, Enable1, PhraseSaveBtn
Return
;=========================================== GUI画面を閉じたときの処理
2ConfigClose:
2GuiClose:
	;-------------------------------------- リロード後、設定画面を再表示させるように設定する
	IniWrite,1,%IniFileName%,AUTOEXEC,StartUp
	IniWrite,機能設定,%IniFileName%,AUTOEXEC,ShowConfigPanel
	;-------------------------------------- リロード後の復元情報をクリアする
	IniWrite,0,%IniFileName%,AUTOEXEC,FP_GrSelectedRow
	IniWrite,0,%IniFileName%,AUTOEXEC,FP_PhSelectedRow
	;-------------------------------------- リロードして設定を反映させる
	Reload
Return
;=========================================== 定型文グループのリストビューを構築する
BuildPhraseGroupLV:
	For index, OptOdr in FP_OrderMem {
		LV_Add("", FP_GroupNameMem[OptOdr])
	}
Return
;=========================================== ボタンを押せないようにする
PhraseDisableButton:
	GuiControl, Enable0, PhraseLV
	GuiControl, Enable0, PhraseUpBtn
	GuiControl, Enable0, PhraseDownBtn
	GuiControl, Enable0, PhraseDeleteBtn
	GuiControl, Enable0, PhraseSaveBtn
	GuiControl, Enable0, PhraseContents
	GuiControl, Enable0, CopyPhraseToMenuBtn
	GuiControl, Enable0, PhraseMenuText
	GuiControl, Enable0, PhraseClearBtn
	GuiControl, Enable0, PhraseAddBtn
	GuiControl, Enable0, PhraseModifyBtn
	;-------------------------------------- 定型文を編集できないようにする
	EnablePhraseEdit := 0
Return
;=========================================== 再表示時に復元できるようにリストビューの選択状態を保存してリロードする
SaveLastSessionAndReloadFP:
	;------------------- 定型文グループリストビューの選択されている行番号を取得して保存する
	Gui,2:ListView,PhraseGroupLV
	SelectedRow := LV_GetNext(0)
	IniWrite,%SelectedRow%,%IniFileName%,AUTOEXEC,FP_GrSelectedRow
	;------------------- 定型文リストビューの選択されている行番号を取得して保存する
	Gui,2:ListView,PhraseLV
	SelectedRow := LV_GetNext(0)
	IniWrite,%SelectedRow%,%IniFileName%,AUTOEXEC,FP_PhSelectedRow
	;-------------------------------------- リロード後、設定画面を再表示させるように設定する
	IniWrite,1,%IniFileName%,AUTOEXEC,StartUp
	IniWrite,定型文機能設定,%IniFileName%,AUTOEXEC,ShowConfigPanel
	;-------------------------------------- リロードして設定を反映させる
	Reload
Return